/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: concerto.metamodel

// imports
import {IConcept} from './concerto';

// interfaces
export interface IDecoratorLiteral extends IConcept {
}

export interface IDecoratorString extends IDecoratorLiteral {
   value: string;
}

export interface IDecoratorNumber extends IDecoratorLiteral {
   value: number;
}

export interface IDecoratorBoolean extends IDecoratorLiteral {
   value: boolean;
}

export interface ITypeIdentifier extends IConcept {
   fullyQualifiedName: string;
}

export interface IDecoratorIdentifier extends IDecoratorLiteral {
   identifier: ITypeIdentifier;
   isArray: boolean;
}

export interface IDecorator extends IConcept {
   name: string;
   arguments?: IDecoratorLiteral[];
}

export interface IClassDeclaration extends IConcept {
   decorators?: IDecorator[];
   isAbstract: boolean;
   identifier: string;
   identifiedByField?: string;
   superType?: ITypeIdentifier;
}

export interface IAssetDeclaration extends IClassDeclaration {
}

export interface IParticipantDeclaration extends IClassDeclaration {
}

export interface ITransactionDeclaration extends IClassDeclaration {
}

export interface IEventDeclaration extends IClassDeclaration {
}

export interface IConceptDeclaration extends IClassDeclaration {
}

export interface IEnumDeclaration extends IClassDeclaration {
}

export interface IStringDefault extends IConcept {
   value: string;
}

export interface IBooleanDefault extends IConcept {
   value: boolean;
}

export interface IIntegerDefault extends IConcept {
   value: number;
}

export interface IRealDefault extends IConcept {
   value: number;
}

export interface IFieldDeclaration extends IConcept {
   name: string;
   isArray?: boolean;
   isOptional?: boolean;
   decorators?: IDecorator[];
}

export interface IObjectFieldDeclaration extends IFieldDeclaration {
   defaultValue?: IStringDefault;
   type: ITypeIdentifier;
}

export interface IBooleanFieldDeclaration extends IFieldDeclaration {
   defaultValue?: IBooleanDefault;
}

export interface IDateTimeFieldDeclaration extends IFieldDeclaration {
}

export interface IStringFieldDeclaration extends IFieldDeclaration {
   defaultValue?: IStringDefault;
   validator?: IStringRegexValidator;
}

export interface IStringRegexValidator extends IConcept {
   regex: string;
}

export interface IRealDomainValidator extends IConcept {
   lower?: number;
   upper?: number;
}

export interface IIntegerDomainValidator extends IConcept {
   lower?: number;
   upper?: number;
}

export interface IRealFieldDeclaration extends IFieldDeclaration {
   defaultValue?: IRealDefault;
   validator?: IRealDomainValidator;
}

export interface IIntegerFieldDeclaration extends IFieldDeclaration {
   defaultValue?: IIntegerDefault;
   validator?: IIntegerDomainValidator;
}

export interface IRelationshipDeclaration extends IFieldDeclaration {
   type: ITypeIdentifier;
}

export interface IImport extends IConcept {
   uri?: string;
}

export interface INamespaceImport extends IImport {
   namespace: string;
}

export interface ITypeImport extends IImport {
   identifier: ITypeIdentifier;
}

export interface IModelFile extends IConcept {
   namespace: string;
   imports?: IImport[];
   declarations?: IClassDeclaration[];
}

